﻿namespace FrequencyAnalysis1
{
    class LetterFrequencies
    {
        public static LetterFrequencies StandardLetterFrequencies()
        {
            return new LetterFrequencies(new LetterFrequency[]
            {
                new LetterFrequency('A',  8167),
                new LetterFrequency('B',  1492),
                new LetterFrequency('C',  2782),
                new LetterFrequency('D',  4253),
                new LetterFrequency('E', 12702),
                new LetterFrequency('F',  2228),
                new LetterFrequency('G',  2015),
                new LetterFrequency('H',  6094),
                new LetterFrequency('I',  6966),
                new LetterFrequency('J',   153),
                new LetterFrequency('K',   772),
                new LetterFrequency('L',  4025),
                new LetterFrequency('M',  2406),
                new LetterFrequency('N',  6749),
                new LetterFrequency('O',  7507),
                new LetterFrequency('P',  1929),
                new LetterFrequency('Q',    95),
                new LetterFrequency('R',  5987),
                new LetterFrequency('S',  6327),
                new LetterFrequency('T',  9056),
                new LetterFrequency('U',  2758),
                new LetterFrequency('V',   978),
                new LetterFrequency('W',  2360),
                new LetterFrequency('X',   150),
                new LetterFrequency('Y',  1974),
                new LetterFrequency('Z',    74)
            });
        }

        public LetterFrequencies()
        {
            Letters = new LetterFrequency[]
            {
                new LetterFrequency('A', 0),
                new LetterFrequency('B', 0),
                new LetterFrequency('C', 0),
                new LetterFrequency('D', 0),
                new LetterFrequency('E', 0),
                new LetterFrequency('F', 0),
                new LetterFrequency('G', 0),
                new LetterFrequency('H', 0),
                new LetterFrequency('I', 0),
                new LetterFrequency('J', 0),
                new LetterFrequency('K', 0),
                new LetterFrequency('L', 0),
                new LetterFrequency('M', 0),
                new LetterFrequency('N', 0),
                new LetterFrequency('O', 0),
                new LetterFrequency('P', 0),
                new LetterFrequency('Q', 0),
                new LetterFrequency('R', 0),
                new LetterFrequency('S', 0),
                new LetterFrequency('T', 0),
                new LetterFrequency('U', 0),
                new LetterFrequency('V', 0),
                new LetterFrequency('W', 0),
                new LetterFrequency('X', 0),
                new LetterFrequency('Y', 0),
                new LetterFrequency('Z', 0)
            };
        }

        public LetterFrequencies(LetterFrequency[] ALetters)
        {
            Letters = ALetters;
        }

        public void Add(char ALetter)
        {
            int LetterNum = Find(ALetter);
            if(LetterNum >= 0)
            {
                Letters[LetterNum].Frequency++;
            }
        }

        public void Sort()
        {
            // TO DO
        }

        public int Find(char ALetter)
        {
            int Result = -1;

            for (int LetterNum = 0; LetterNum < Letters.Length; LetterNum++)
            {
                if (Letters[LetterNum].Letter == ALetter)
                {
                    Result = LetterNum;
                    break;
                }
            }

            return Result;
        }

        public void Swap(int AtLetter)
        {
// TO DO
        }

        public LetterFrequency[] Letters = null;
    }
}
